org.fife.ui.rsyntaxtextarea

## Class AbstractJFlexCTokenMaker

- java.lang.Object
- - org.fife.ui.rsyntaxtextarea.AbstractJFlexTokenMaker
  - - org.fife.ui.rsyntaxtextarea.AbstractJFlexCTokenMaker

All Implemented Interfaces:
  TokenMaker

Direct Known Subclasses:
  ActionScriptTokenMaker, CPlusPlusTokenMaker, CSharpTokenMaker, CTokenMaker, GroovyTokenMaker, JavaScriptTokenMaker, JavaTokenMaker, NSISTokenMaker, PerlTokenMaker, ScalaTokenMaker, TclTokenMaker

    public abstract class AbstractJFlexCTokenMaker
    extends AbstractJFlexTokenMaker

Base class for JFlex-based token makers using C-style syntax. This class knows how to auto-indent after opening braces and parens.

Version:
  1.0
Author:
  Robert Futrell

### Field Summary

Fields
`protected TokenImpl` `currentToken` Used in the creation of the linked list.
`protected TokenImpl` `firstToken` The first token in the returned linked list.
`protected static Action` `INSERT_BREAK_ACTION`
`protected TokenImpl` `previousToken` Used in the creation of the linked list.

### Fields inherited from class org.fife.ui.rsyntaxtextarea.AbstractJFlexTokenMaker

`offsetShift, s, start`

### Constructor Summary

Constructors
Constructor and Description
`AbstractJFlexCTokenMaker()`

### Method Summary

Methods
`void` `addNullToken()` Adds a null token to the end of the current linked list of tokens.
`void` `addToken(char[] array, int start, int end, int tokenType, int startOffset)` Adds the token specified to the current linked list of tokens.
`void` `addToken(char[] array, int start, int end, int tokenType, int startOffset, boolean hyperlink)` Adds the token specified to the current linked list of tokens.
`void` `addToken(Segment segment, int start, int end, int tokenType, int startOffset)` Adds the token specified to the current linked list of tokens.
`protected OccurrenceMarker` `createOccurrenceMarker()` Returns the occurrence marker to use for this token maker.
`int` `getClosestStandardTokenTypeForInternalType(int type)` Returns the closest `"standard" token type` for a given "internal" token type (e.g. one whose value is `< 0`).
`boolean` `getCurlyBracesDenoteCodeBlocks()` Returns `true` always as C-style languages use curly braces to denote code blocks.
`Action` `getInsertBreakAction()` Returns an action to handle "insert break" key presses (i.e.
`int` `getLastTokenTypeOnLine(Segment text, int initialTokenType)` Returns the last token on this line's type if the token is "unfinished", or `TokenTypes.NULL` if it was finished.
`String[]` `getLineCommentStartAndEnd()` Returns the text to place at the beginning and end of a line to "comment" it in a this programming language.
`boolean` `getMarkOccurrencesOfTokenType(int type)` Returns whether tokens of the specified type should have "mark occurrences" enabled for the current programming language.
`OccurrenceMarker` `getOccurrenceMarker()` Returns the object in charge of marking all occurrences of the token at the current caret position, if it is a relevant token.
`boolean` `getShouldIndentNextLineAfter(Token t)` The default implementation returns `false` always.
`boolean` `isMarkupLanguage()` The default implementation returns `false` always.
`protected void` `resetTokenList()` Deletes the linked list of tokens so we can begin anew.
`void` `setLanguageIndex(int languageIndex)` Sets the language index to assign to tokens moving forward.

### Methods inherited from class org.fife.ui.rsyntaxtextarea.AbstractJFlexTokenMaker

`yybegin, yybegin`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.fife.ui.rsyntaxtextarea.TokenMaker

`getTokenList`

### Field Detail

#### INSERT_BREAK_ACTION

    protected static final Action INSERT_BREAK_ACTION

#### firstToken

    protected TokenImpl firstToken

The first token in the returned linked list.

#### currentToken

    protected TokenImpl currentToken

Used in the creation of the linked list.

#### previousToken

    protected TokenImpl previousToken

Used in the creation of the linked list.

### Constructor Detail

#### AbstractJFlexCTokenMaker

    public AbstractJFlexCTokenMaker()

### Method Detail

#### getCurlyBracesDenoteCodeBlocks

    public boolean getCurlyBracesDenoteCodeBlocks()

Returns `true` always as C-style languages use curly braces to denote code blocks.

Specified by:
  `getCurlyBracesDenoteCodeBlocks` in interface `TokenMaker`
Returns:
  `true` always.

#### getInsertBreakAction

    public Action getInsertBreakAction()

Returns an action to handle "insert break" key presses (i.e. Enter). An action is returned that handles newlines differently in multi-line comments.

Specified by:
  `getInsertBreakAction` in interface `TokenMaker`
Returns:
  The action.

#### getMarkOccurrencesOfTokenType

    public boolean getMarkOccurrencesOfTokenType(int type)

Returns whether tokens of the specified type should have "mark occurrences" enabled for the current programming language. The default implementation returns true if `type` is `TokenTypes.IDENTIFIER`. Subclasses can override this method to support other token types, such as `TokenTypes.VARIABLE`.

Specified by:
  `getMarkOccurrencesOfTokenType` in interface `TokenMaker`
Parameters:
  `type` - The token type.
Returns:
  Whether tokens of this type should have "mark occurrences" enabled.

#### getShouldIndentNextLineAfter

    public boolean getShouldIndentNextLineAfter(Token t)

The default implementation returns `false` always. Languages that wish to better support auto-indentation can override this method.

Specified by:
  `getShouldIndentNextLineAfter` in interface `TokenMaker`
Parameters:
  `t` - The token the previous line ends with.
Returns:
  Whether the next line should be indented.

#### addNullToken

    public void addNullToken()

Adds a null token to the end of the current linked list of tokens. This should be put at the end of the linked list whenever the last token on the current line is NOT a multi-line token.

Specified by:
  `addNullToken` in interface `TokenMaker`

#### addToken

    public void addToken(Segment segment,
                int start,
                int end,
                int tokenType,
                int startOffset)

Adds the token specified to the current linked list of tokens.

Parameters:
  `segment` - `Segment` to get text from.
  `start` - Start offset in `segment` of token.
  `end` - End offset in `segment` of token.
  `tokenType` - The token's type.
  `startOffset` - The offset in the document at which this token occurs.

#### addToken

    public void addToken(char[] array,
                int start,
                int end,
                int tokenType,
                int startOffset)

Adds the token specified to the current linked list of tokens.

Specified by:
  `addToken` in interface `TokenMaker`
Parameters:
  `array` - The character array from which to get the text.
  `start` - Start offset in `segment` of token.
  `end` - End offset in `segment` of token.
  `tokenType` - The token's type.
  `startOffset` - The offset in the document at which this token occurs.

#### addToken

    public void addToken(char[] array,
                int start,
                int end,
                int tokenType,
                int startOffset,
                boolean hyperlink)

Adds the token specified to the current linked list of tokens.

Parameters:
  `array` - The character array.
  `start` - The starting offset in the array.
  `end` - The ending offset in the array.
  `tokenType` - The token's type.
  `startOffset` - The offset in the document at which this token occurs.
  `hyperlink` - Whether this token is a hyperlink.

#### createOccurrenceMarker

    protected OccurrenceMarker createOccurrenceMarker()

Returns the occurrence marker to use for this token maker. Subclasses can override to use different implementations.

Returns:
  The occurrence marker to use.

#### getClosestStandardTokenTypeForInternalType

    public int getClosestStandardTokenTypeForInternalType(int type)

Returns the closest `"standard" token type` for a given "internal" token type (e.g. one whose value is `< 0`).

The default implementation returns `type` always, which denotes that a mapping from internal token types to standard token types is not defined; subclasses can override.

Specified by:
  `getClosestStandardTokenTypeForInternalType` in interface `TokenMaker`
Parameters:
  `type` - The token type.
Returns:
  The closest "standard" token type.

#### getLastTokenTypeOnLine

    public int getLastTokenTypeOnLine(Segment text,
                             int initialTokenType)

Returns the last token on this line's type if the token is "unfinished", or `TokenTypes.NULL` if it was finished. For example, if C-style syntax highlighting is being implemented, and `text` contained a line of code that contained the beginning of a comment but no end-comment marker ("*\/"), then this method would return `TokenTypes.COMMENT_MULTILINE` for that line. This is useful for doing syntax highlighting.

Specified by:
  `getLastTokenTypeOnLine` in interface `TokenMaker`
Parameters:
  `text` - The line of tokens to examine.
  `initialTokenType` - The token type to start with (i.e., the value of `getLastTokenTypeOnLine` for the line before `text`).
Returns:
  The last token on this line's type, or `TokenTypes.NULL` if the line was completed.

#### getLineCommentStartAndEnd

    public String[] getLineCommentStartAndEnd()

Returns the text to place at the beginning and end of a line to "comment" it in a this programming language.

Specified by:
  `getLineCommentStartAndEnd` in interface `TokenMaker`
Returns:
  The start and end strings to add to a line to "comment" it out. A `null` value for either means there is no string to add for that part. A value of `null` for the array means this language does not support commenting/uncommenting lines.

#### getOccurrenceMarker

    public OccurrenceMarker getOccurrenceMarker()

Returns the object in charge of marking all occurrences of the token at the current caret position, if it is a relevant token. If `null` is returned, a default `OccurrenceMarker` is used.

Specified by:
  `getOccurrenceMarker` in interface `TokenMaker`
Returns:
  The occurrence marker for this language, or `null` for none.

#### isMarkupLanguage

    public boolean isMarkupLanguage()

The default implementation returns `false` always. Subclasses that are highlighting a markup language should override this method to return `true`.

Specified by:
  `isMarkupLanguage` in interface `TokenMaker`
Returns:
  `false` always.

#### resetTokenList

    protected void resetTokenList()

Deletes the linked list of tokens so we can begin anew. This should never have to be called by the programmer, as it is automatically called whenever the user calls `getLastTokenTypeOnLine(Segment, int)` or `TokenMaker.getTokenList(Segment, int, int)`.

#### setLanguageIndex

    public void setLanguageIndex(int languageIndex)

Sets the language index to assign to tokens moving forward. This property is used to designate tokens as being in "secondary" languages (such as CSS or JavaScript in HTML).

Parameters:
  `languageIndex` - The new language index. A value of `0` denotes the "main" language, any positive value denotes a specific secondary language. Negative values will be treated as `0`.